summaryrefslogtreecommitdiffstats
path: root/cm-container/start-persistent.sh
diff options
context:
space:
mode:
authorJack Lucas <jflucas@research.att.com>2018-12-04 15:02:06 -0500
committerJack Lucas <jflucas@research.att.com>2018-12-04 15:03:25 -0500
commit8ad4f6db9865a9a9fb9076c9ce9e07e91a1519ea (patch)
tree9995d6441f1c378dc3a56fea4eb2f93aae53d164 /cm-container/start-persistent.sh
parente24fb188c483acce93fc5419690792c2300161cf (diff)
Add persistent storage for CM state information
Issue-ID: DCAEGEN2-990 Change-Id: I122e541d6ea0fa6bca06157d6ae7a330048d2ed7 Signed-off-by: Jack Lucas <jflucas@research.att.com>
Diffstat (limited to 'cm-container/start-persistent.sh')
-rwxr-xr-xcm-container/start-persistent.sh53
1 files changed, 53 insertions, 0 deletions
diff --git a/cm-container/start-persistent.sh b/cm-container/start-persistent.sh
new file mode 100755
index 0000000..bf55da0
--- /dev/null
+++ b/cm-container/start-persistent.sh
@@ -0,0 +1,53 @@
+#!/bin/bash
+# ================================================================================
+# Copyright (c) 2018 AT&T Intellectual Property. All rights reserved.
+# ================================================================================
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at
+#
+# http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+# ============LICENSE_END=========================================================
+# Set up persistent storage for Cloudify Manager's state data
+
+PDIRS="/var/lib/pgsql/9.5/data /opt/manager/resources /opt/mgmtworker/env/plugins /opt/mgmtworker/work/deployments"
+PSTORE="/cfy-persist"
+
+set -ex
+
+if [ -d "$PSTORE" ]
+then
+ # the persistent mount point exists
+ if [ -z "$(ls -A $PSTORE)" ]
+ then
+ # there's nothing in the persistent store yet
+ # copy in the data from the container file system
+ for d in $PDIRS
+ do
+ p="$(dirname $d)"
+ mkdir -p "${PSTORE}$p"
+ cp -rp "$d" "${PSTORE}$p"
+ done
+ fi
+ # at this point, there is persistent storage possibly from a previous startup
+ # set up links from internal file system to persistent storage
+ for d in $PDIRS
+ do
+ if [ -d "$d" ]
+ then
+ mv $d $d-initial # move directory so we can create symlink
+ fi
+ ln -sf "$PSTORE/$d" "$(dirname $d)"
+ done
+else
+ echo "No persistent storage available"
+fi
+# start up init, which brings up CM and supporting software
+exec /sbin/init --log-target=journal 3>&1
+